package com.sun.beans.decoder;

import java.lang.reflect.Method;
import sun.reflect.misc.MethodUtil;
import com.sun.beans.finder.MethodFinder;

final class MethodElementHandler extends NewElementHandler
{
    private String name;
    
    MethodElementHandler() {
    }
    
    @Override
    public void addAttribute(String s, String name) {
        if (s.equals("name")) {
            this.name = name;
        }
        else {
            super.addAttribute(s, name);
        }
    }
    
    protected ValueObject getValueObject(Class<?> type, Object[] arguments) throws Exception {
        Object contextBean = this.getContextBean();
        Class[] argumentTypes = NewElementHandler.getArgumentTypes(arguments);
        Method m = (type != null) ? MethodFinder.findStaticMethod(type, this.name, argumentTypes) : MethodFinder.findMethod(contextBean.getClass(), this.name, argumentTypes);
        if (m.isVarArgs()) {
            arguments = NewElementHandler.getArguments(arguments, m.getParameterTypes());
        }
        Object invoke = MethodUtil.invoke(m, contextBean, arguments);
        return m.getReturnType().equals(Void.TYPE) ? ValueObjectImpl.VOID : ValueObjectImpl.create(invoke);
    }
}
